:- use_module(library(clpfd)).
 
sendmoremoney(Vars) :-
    Vars = [S,E,N,D,M,O,R,Y],
    Vars ins 0..9,
    S #\= 0,
    M #\= 0,
    all_different(Vars),
                 1000*S + 100*E + 10*N + D
    +            1000*M + 100*O + 10*R + E
    #= 10000*M + 1000*O + 100*N + 10*E + Y.

solve(Vars):- Vars=[S,E,N,D,M,O,R,Y],sendmoremoney([S,E,N,D,M,O,R,Y]),label(Vars).



send5(Vars,Cars) :-
    Cars = [C1,C2,C3,C4],
    Cars ins 0..1,
    Vars = [S,E,N,D,M,O,R,Y],
    Vars ins 0..9,
    all_different(Vars),
    S #\= 0,
    M #\= 0,
    M #= C4,
    D + E      #= 10*C1 + Y,
    N + R + C1 #= 10*C2 + E, 
    E + O + C2 #= 10*C3 + N,
    S + M + C3 #= 10*C4 + O.
    
solve5(Vars,Cars):- Vars=[S,E,N,D,M,O,R,Y],Cars=[C1,C2,C3,C4], 
                 send5([S,E,N,D,M,O,R,Y],[C1,C2,C3,C4]),label(Vars),label(Cars).

puzzle([S,E,N,D] + [M,O,R,E] = [M,O,N,E,Y]) :-
        Vars = [S,E,N,D,M,O,R,Y],
        Vars ins 0..9,
        all_different(Vars),
                  S*1000 + E*100 + N*10 + D +
                  M*1000 + O*100 + R*10 + E #=
        M*10000 + O*1000 + N*100 + E*10 + Y,
        M #\= 0, S #\= 0.


go3(Send,More,Money):- puzzle(Send+More=Money),label(Send).
