% Program do rozwiazywania lamiglowki Sudoku
% autor:    Bartlomiej Pfajfer
% kierunek: Informatyka Stosowana IV
% uczelnia: PWSZ Tarnow
% data:     18-01-2010


% otwiera/zamyka plik
        odczytaj(Plik,Lista) :-
                       see(Plik),
                       przegladaj([],R),
                       reverse(R,Lista),
                       seen.


% wpisuje liczby z pliku na liste
        przegladaj(WejsciowaLista,WyjsciowaLista):-
                       read(Dana),
                       (
                           Dana == end_of_file ->
                           WyjsciowaLista = WejsciowaLista;
                           przegladaj([Dana|WejsciowaLista],WyjsciowaLista)
                       ).


% rozmiar listy
        rozmiar_listy([],0).
        rozmiar_listy([_|OgonListy],RozmiarListy) :-
                        rozmiar_listy(OgonListy,RozmiarOgona),
                        RozmiarListy is RozmiarOgona + 1.


% podziel_wierszami(Lista,W)
% dzieli liste na liste list dziewiecio-elementowych
% wynikowe listy na liscie sa wierszami planszy
        podziel_wierszami([],[[]]).
        podziel_wierszami([A,B,C,D,E,F,G,H,I|OgonListy],W) :-
                        podziel_wierszami(OgonListy,N),
                        append([[A,B,C,D,E,F,G,H,I]],N,W).


% wybor n-tego elementu z listy
        element_listy([H|_],0,H).
        element_listy([_|OgonListy],NrElementu,Element) :-
                        NowyNrElementu is NrElementu - 1,
                        element_listy(OgonListy,NowyNrElementu,Element).


% Przedzial obustronnie domkniety, sprawdza czy liczba nalezy do przedzialu
        pod(X,Y,Z) :-
                        X =< Y,
                        Y =< Z.


% podziel_kolumnami(Lista,K)
% dzieli liste 81-elementowa na liste 9 list dziewiecio-elementowych
% wynikowe listy na liscie sa kolumanami planszy
        podziel_kolumnami(Lista,K) :-
                        podziel_kolumnami(Lista,K,[[],[],[],[],[],[],[],[],[]],81).

        podziel_kolumnami(_,K,K,Licznik) :-
                        Licznik == 0, !.
        podziel_kolumnami(Lista,K,[A,B,C,D,E,F,G,H,I],Licznik) :-
                        Licznik > 0,
                        RLicznik is 81 - Licznik,
                        NrKolumny is RLicznik mod 9,
                        ZmLicznik is Licznik - 1,
                        element_listy(Lista,RLicznik,Element),
                        (
                                NrKolumny = 0, append(A,[Element],A1), podziel_kolumnami(Lista,K,[A1,B,C,D,E,F,G,H,I],ZmLicznik);
                                NrKolumny = 1, append(B,[Element],B1), podziel_kolumnami(Lista,K,[A,B1,C,D,E,F,G,H,I],ZmLicznik);
                                NrKolumny = 2, append(C,[Element],C1), podziel_kolumnami(Lista,K,[A,B,C1,D,E,F,G,H,I],ZmLicznik);
                                NrKolumny = 3, append(D,[Element],D1), podziel_kolumnami(Lista,K,[A,B,C,D1,E,F,G,H,I],ZmLicznik);
                                NrKolumny = 4, append(E,[Element],E1), podziel_kolumnami(Lista,K,[A,B,C,D,E1,F,G,H,I],ZmLicznik);
                                NrKolumny = 5, append(F,[Element],F1), podziel_kolumnami(Lista,K,[A,B,C,D,E,F1,G,H,I],ZmLicznik);
                                NrKolumny = 6, append(G,[Element],G1), podziel_kolumnami(Lista,K,[A,B,C,D,E,F,G1,H,I],ZmLicznik);
                                NrKolumny = 7, append(H,[Element],H1), podziel_kolumnami(Lista,K,[A,B,C,D,E,F,G,H1,I],ZmLicznik);
                                NrKolumny = 8, append(I,[Element],I1), podziel_kolumnami(Lista,K,[A,B,C,D,E,F,G,H,I1],ZmLicznik)
                        ).


% podziel_kwadratami(Lista,Kw)
% dzieli liste 81-elementowa na liste 9 list dziewiecio-elementowych
% wynikowe listy na liscie sa logicznymi kwadratami na planszy
        podziel_kwadratami(Lista,Kw) :-
                        podziel_kwadratami(Lista,Kw,[[],[],[],[],[],[],[],[],[]],81).

        podziel_kwadratami(_,Kw,Kw,Licznik) :-
                        Licznik == 0, !.
        podziel_kwadratami(Lista,Kw,[A,B,C,D,E,F,G,H,I],Licznik) :-
                        Licznik > 0,
                %       write(Licznik), write(' '),
                        RLicznik is 81 - Licznik,
                        NrKolumny is RLicznik mod 9,
                        NrWiersza is integer((RLicznik / 9) - 0.49), %ciekawe
                %       write(RLicznik), write(' '), write(NrWiersza),
                %       nl,
                        ZmLicznik is Licznik - 1,
                        element_listy(Lista,RLicznik,Element),
                        (
                                pod(0,NrKolumny,2), pod(0,NrWiersza,2), append(A,[Element],A1), podziel_kwadratami(Lista,Kw,[A1,B,C,D,E,F,G,H,I],ZmLicznik);
                                pod(3,NrKolumny,5), pod(0,NrWiersza,2), append(B,[Element],B1), podziel_kwadratami(Lista,Kw,[A,B1,C,D,E,F,G,H,I],ZmLicznik);
                                pod(6,NrKolumny,8), pod(0,NrWiersza,2), append(C,[Element],C1), podziel_kwadratami(Lista,Kw,[A,B,C1,D,E,F,G,H,I],ZmLicznik);
                                pod(0,NrKolumny,2), pod(3,NrWiersza,5), append(D,[Element],D1), podziel_kwadratami(Lista,Kw,[A,B,C,D1,E,F,G,H,I],ZmLicznik);
                                pod(3,NrKolumny,5), pod(3,NrWiersza,5), append(E,[Element],E1), podziel_kwadratami(Lista,Kw,[A,B,C,D,E1,F,G,H,I],ZmLicznik);
                                pod(6,NrKolumny,8), pod(3,NrWiersza,5), append(F,[Element],F1), podziel_kwadratami(Lista,Kw,[A,B,C,D,E,F1,G,H,I],ZmLicznik);
                                pod(0,NrKolumny,2), pod(6,NrWiersza,8), append(G,[Element],G1), podziel_kwadratami(Lista,Kw,[A,B,C,D,E,F,G1,H,I],ZmLicznik);
                                pod(3,NrKolumny,5), pod(6,NrWiersza,8), append(H,[Element],H1), podziel_kwadratami(Lista,Kw,[A,B,C,D,E,F,G,H1,I],ZmLicznik);
                                pod(6,NrKolumny,8), pod(6,NrWiersza,8), append(I,[Element],I1), podziel_kwadratami(Lista,Kw,[A,B,C,D,E,F,G,H,I1],ZmLicznik)
                        ).


% sprawdza czy lista zawiera podany element
        lista_zawiera(Element,[Element|_]).
        lista_zawiera(Element,[_|Reszta]) :-
                        lista_zawiera(Element,Reszta).


% sprawdza czy lista nie zawiera podanego elementu
        lista_nie_zawiera(Element,Lista) :-
                        not(lista_zawiera(Element,Lista)).


% brakujace_elementy(L,B)
% w liscie B zwraca permutacje liczb ktorymi mozna uzupelnic zera w liscie L
% Przyklad:
% brakujace_elementy([1,4,6,2,0,5,0,0,9],B).
% B = [3, 7, 8] ;
% B = [3, 8, 7] ;
% B = [7, 3, 8] ;
% B = [7, 8, 3] ;
% B = [8, 3, 7] ;
% B = [8, 7, 3] ;
% false.
        brakujace_elementy(L,B) :-
                            brakujace_elementy(L,[],B).

        brakujace_elementy(L,A,B) :-
                            (
                              N is 1, lista_nie_zawiera(N,L), lista_nie_zawiera(N,A), append(A,[N],C), brakujace_elementy(L,C,B);
                              N is 2, lista_nie_zawiera(N,L), lista_nie_zawiera(N,A), append(A,[N],C), brakujace_elementy(L,C,B);
                              N is 3, lista_nie_zawiera(N,L), lista_nie_zawiera(N,A), append(A,[N],C), brakujace_elementy(L,C,B);
                              N is 4, lista_nie_zawiera(N,L), lista_nie_zawiera(N,A), append(A,[N],C), brakujace_elementy(L,C,B);
                              N is 5, lista_nie_zawiera(N,L), lista_nie_zawiera(N,A), append(A,[N],C), brakujace_elementy(L,C,B);
                              N is 6, lista_nie_zawiera(N,L), lista_nie_zawiera(N,A), append(A,[N],C), brakujace_elementy(L,C,B);
                              N is 7, lista_nie_zawiera(N,L), lista_nie_zawiera(N,A), append(A,[N],C), brakujace_elementy(L,C,B);
                              N is 8, lista_nie_zawiera(N,L), lista_nie_zawiera(N,A), append(A,[N],C), brakujace_elementy(L,C,B);
                              N is 9, lista_nie_zawiera(N,L), lista_nie_zawiera(N,A), append(A,[N],C), brakujace_elementy(L,C,B)
                            ).

        brakujace_elementy(L,A,A) :-
                          policz_zera(L,Z), dlugosc_listy(A,D), Z == D.     % wszystkie zera musza byc zastapione


% zlicza ilosc zer w liscie
        policz_zera([],0).
        policz_zera([H|T],Z) :-
                           H == 0,
                           policz_zera(T,X),
                           Z is X + 1.
        policz_zera([H|T],Z) :-
                           H \== 0,
                           policz_zera(T,Z).


% dlugosc listy
        dlugosc_listy([],0).
        dlugosc_listy([_|T],L) :-
                            dlugosc_listy(T,L2),
                            L is L2 + 1.


% zastap_zera(LZ,LBZ)
% zastepuje zera na liscie LZ mozliwymi permutacjami brakujacych liczb
% Przyklad:
% zastap_zera([1,4,6,2,0,5,0,0,9],LBZ).
% LBZ = [1, 4, 6, 2, 3, 5, 7, 8, 9] ;
% LBZ = [1, 4, 6, 2, 3, 5, 8, 7, 9] ;
% LBZ = [1, 4, 6, 2, 7, 5, 3, 8, 9] ;
% LBZ = [1, 4, 6, 2, 7, 5, 8, 3, 9] ;
% LBZ = [1, 4, 6, 2, 8, 5, 3, 7, 9] ;
% LBZ = [1, 4, 6, 2, 8, 5, 7, 3, 9] ;
% false.
        zastap_zera(LZ,LBZ) :-
                            brakujace_elementy(LZ,[],B),
                            zastap_zera(LZ,B,[],LBZ).
        zastap_zera([],[],A,A).
        zastap_zera([H|T],[BH|BT],A,LBZ) :-
                            H == 0,
                            append(A,[BH],C),
                            zastap_zera(T,BT,C,LBZ).
        zastap_zera([H|T],B,A,LBZ) :-
                            H \== 0,
                            append(A,[H],C),
                            zastap_zera(T,B,C,LBZ).


% sa_powtorzenia([Element|Reszta])
% sprawdza czy jakas liczba oprocz zera powtarza sie na liscie
        sa_powtorzenia([]) :- false.
        sa_powtorzenia([Element|Reszta]) :-
                            Element \== 0,
                            lista_nie_zawiera(Element,Reszta),
                            sa_powtorzenia(Reszta).
        sa_powtorzenia([Element|Reszta]) :-
                            Element \== 0,
                            lista_zawiera(Element,Reszta).
        sa_powtorzenia([Element|Reszta]) :-
                            Element == 0,
                            sa_powtorzenia(Reszta).


% wypisywanie na ekran
        wypisz_wiersz([]) :- nl.
        wypisz_wiersz([H|T]) :-
                            write(H),
                            write(' '),
                            wypisz_wiersz(T).
        wypisz([]) :- nl.
        wypisz([H|T]) :-
                            wypisz_wiersz(H),
                            wypisz(T).


% sprawdz_poprawnosc(L)
% sprawdza czy lista L (81-elementowa) opisujaca plansze nie zawiera konfliktow
% np. powtarzajace sie liczby w kolumnie,wierszu lub kwadracie logicznym
        sprawdz_poprawnosc(L) :-
                            podziel_kolumnami(L,K),
                            sprawdz_poprawnosc_listy(K),
                            podziel_kwadratami(L,Kw),
                            sprawdz_poprawnosc_listy(Kw).
                         %  podziel_wierszami(L,W),             % rozwiazania sa generowane wierszami wiec sprawdzanie poprawnosci wierszy jest niepotrzebne
                         %  sprawdz_poprawnosc_listy(W).


% sprawdz_poprawnosc_listy([H|T])
% sprawdza czy lista list opisujaca plansze nie zawiera konfliktow
        sprawdz_poprawnosc_listy([]) :- true.
        sprawdz_poprawnosc_listy([H|T]) :-
                            not(sa_powtorzenia(H)),
                            sprawdz_poprawnosc_listy(T).
        sprawdz_poprawnosc_listy([H|_]) :-
                            sa_powtorzenia(H),
                            fail.


% zastap_czesc_listy(ListaOryginalna,NowaLista,Miejsce,WynikowaLista)
% 'naklada' nowa liste na stara od podanego miejsca
% Przyklady:
% zastap_czesc_listy([1,2,3,4,5,6,7,8,9],[9,8,7],2,X).
% X = [1, 2, 9, 8, 7, 6, 7, 8, 9] ;
% false.
%
% zastap_czesc_listy([1,1,1,1,1,1,1],[2,2,2],0,X).
% X = [2, 2, 2, 1, 1, 1, 1] ;
% false.

        zastap_czesc_listy(ListaOryginalna,NowaLista,Miejsce,WynikowaLista) :-
                            pierwsze_N_elementow_listy(ListaOryginalna,Miejsce,PierwszeElementy),
                            rozmiar_listy(NowaLista,Rozmiar),
                            MiejsceZaNowymiElementami is Rozmiar + Miejsce,
                            elementy_listy_od_Ntego_elementu(ListaOryginalna,MiejsceZaNowymiElementami,OstatnieElementy),
                            append(PierwszeElementy,NowaLista,Tmp),
                            append(Tmp,OstatnieElementy,WynikowaLista).


%
        pierwsze_N_elementow_listy(_,0,[]).
        pierwsze_N_elementow_listy([H|T],N,[H|T2]) :-
                            N > 0,
                            M is N - 1,
                            pierwsze_N_elementow_listy(T,M,T2).


%
        elementy_listy_od_Ntego_elementu(L,N,W) :-
                            pierwsze_N_elementow_listy(L,N,P),
                            append(P,W,L).


% rozwiaz_sudoku(Plik)
% glowny term, odczytuje opis planszy, rozwiazuje, wypisuje na ekran
        rozwiaz_sudoku(Plik) :-
                            get_time(Start),
                            odczytaj(Plik,L),               % L - 81 lista liczb opisujaca plansze, zera na liscie to szukane elementy
                            rozmiar_listy(L,Rozmiar),
                            Rozmiar == 81,
                            podziel_wierszami(L,W),         % dzieli wczytania z pliku liste na liste list 9-elementowych ktore reprezentuja wiersze planszy
                            nl,
                            write('Zadanie:'),
                            nl,
                            wypisz(W),
                            rozwiaz(W,L,Rozwiazanie,0),     % Rozwiazanie w postaci listy 9 list 9-elementowych
                            nl,
                            write('Rozwiazanie:'),
                            nl,
                            wypisz(Rozwiazanie),
                            get_time(Koniec),
                            Czas is Koniec - Start,
                            write('Czas wykonania: '),
                            write(Czas),
                            !.                              % przy pierwszym znalezionym rozwiazaniu przerywa dzialanie

         
% rozwiaz(Wiersze,Plansza,Rozwiazanie,MiejsceZastepowania)
% dla niewiadomego wiersza planszy generuje permutacje brakujacych liczb w wierszu i umieszcza je w nim,
% zastepuje wygenerowany wiersz na planszy
% sprawdza czy nie ma konfliktow
% przechodzi do kolejnego wiersza

        rozwiaz([Wiersz|Reszta],Plansza,Rozwiazanie,MiejsceZastepowania) :-
                           MiejsceZastepowania < 81,
                           zastap_zera(Wiersz,MozliwaPermutacjaWiersza),                % dla niewiadomego wiersza planszy generuje permutacje brakujacych liczb w wierszu i umieszcza je w nim
                           zastap_czesc_listy(Plansza,MozliwaPermutacjaWiersza,MiejsceZastepowania,NowaPlansza),    % zastepuje wygenerowany wiersz na planszy
                           sprawdz_poprawnosc(NowaPlansza),                             % sprawdza czy nie ma konfliktow
                           NoweMiejsceZastepowania is MiejsceZastepowania + 9,          % NoweMiejsceZastepowania - pozycja w 81 elementowej liscie w ktorej zaczyna sie nastepny wiersz
                           rozwiaz(Reszta,NowaPlansza,Rozwiazanie,NoweMiejsceZastepowania). % przechodzi do kolejnego wiersza

        rozwiaz(_,Plansza,Rozwiazanie,MiejsceZastepowania) :-
                           MiejsceZastepowania >= 81,
                           podziel_wierszami(Plansza,Rozwiazanie).
 
