
:- dynamic(element/3).          % nr: wiersz, kolumna, wartosc
:- dynamic(wiersz/2).           % nr, wartosc
:- dynamic(kolumna/2).          % nr, wartosc
:- dynamic(kwadrat/2).          % nr, wartosc
:- dynamic(mozliwosc/4).        % wiersz, kolumna, kwadrat, wartosc

:- dynamic(licz_el/1).
:- dynamic(stan_poczatkowy/1).  % zapamituje ile liczb byo zadanych na pocztku
:- dynamic(pamiec_strzelen/3).  % wiersz, kolumna, wartosc

:- dynamic(tmpp/3).

%%%%%%%%%%%      DANE POMOCNICZE        %%%%%%%%%%%%%%
cyfra(1).       cyfra(2).
cyfra(3).       cyfra(4).
cyfra(5).       cyfra(6).
cyfra(7).       cyfra(8).
        cyfra(9).

%%%     modyfikatory rozpoznawania ssiadw
modyf(1,2,3).   modyf(2,1,3).  modyf(3,1,2).
modyf(4,5,6).   modyf(5,4,6).  modyf(6,4,5).
modyf(7,8,9).   modyf(8,7,9).  modyf(9,7,8).

% Przykadowe macierze testowe piekielnie trudna i srednia
% atwy
% [[0,0,6,0,0,0,9,0,0],[0,2,0,6,9,7,0,3,0],[7,0,0,0,8,0,0,0,6],[0,8,0,9,6,3,0,2,0],[0,0,0,0,0,0,0,0,0],[0,1,0,2,4,5,0,7,0],[6,0,0,0,5,0,0,0,1],[0,5,0,8,3,9,0,6,0],[0,0,9,0,0,0,8,0,0]]
% redni
% [[3,9,1,0,0,0,6,5,0],[0,2,0,0,5,0,0,0,3],[0,0,5,0,0,4,1,2,0],[0,0,0,2,0,0,0,0,9],[0,0,0,8,0,1,0,0,0],[7,0,0,0,0,3,0,0,0],[0,1,6,3,0,0,4,0,0],[5,0,0,0,6,0,0,8,0],[0,4,8,0,0,0,7,3,6]]
% Trudny
% [[5,0,0,2,0,4,0,7,0],[0,0,0,9,3,0,0,0,0],[8,3,0,0,0,0,0,0,0],[0,5,0,0,0,9,6,0,0],[6,0,7,0,0,0,2,0,8],[0,0,2,1,0,0,0,5,0],[0,0,0,0,0,0,0,6,2],[0,0,0,0,4,1,0,0,0],[0,8,0,5,0,2,0,0,1]]
% Piekielnie trudny
% [[0,0,0,0,0,9,0,7,0],[0,0,0,1,0,0,0,4,5],[0,3,0,0,0,5,0,0,6],[9,0,0,0,0,0,0,3,4],[0,8,0,9,0,2,0,6,0],[4,5,0,0,0,0,0,0,8],[8,0,0,7,0,0,0,2,0],[6,9,0,0,0,4,0,0,0],[0,1,0,8,0,0,0,0,0]]
% [[0,1,0,0,2,0,4,0,0],[0,0,4,0,0,3,2,0,5],[8,2,0,0,5,4,0,6,0],[1,4,0,0,0,9,0,0,2],[0,3,0,2,0,6,0,4,0],[0,8,2,4,0,0,0,0,7],[0,5,0,7,9,2,0,0,4],[2,0,8,3,4,0,7,0,0],[4,0,0,0,0,0,0,2,0]]


%%%%%%%%%%%      PREDYKATY POMOCNICZE   %%%%%%%%%%%%%%


wypiszListe([]).
wypiszListe([0|T]):-write(0),write('   '), wypiszListe(T),!.
wypiszListe([H|T]):- H =\= 0,write(H),write('   '), wypiszListe(T),!.


wypiszMacierz([H|T]):-
        wypiszListe(H),nl,
        wypiszMacierz(T).
wypiszMacierz([]):-nl.

czyszczenie:- mozliwosc(A,B,C,D),retract(mozliwosc(A,B,C,D)),fail.
czyszczenie:- element(A,B,C),retract(element(A,B,C)),fail.
czyszczenie:- wiersz(A,B),retract(wiersz(A,B)),fail.
czyszczenie:- kolumna(A,B),retract(kolumna(A,B)),fail.
czyszczenie:- kwadrat(A,B),retract(kwadrat(A,B)),fail.
czyszczenie:- licz_el(X),retract(licz_el(X)),fail.
czyszczenie_strzelen :- pamiec_strzelen(W,K,X), retract(pamiec_strzelen(W,K,X)),fail.

liczba_elementow(W):-
        assert(licz_el(0)),
        not(zlicz_elementy),!,
        licz_el(W),
        retract(licz_el(W)),!.

zlicz_elementy:-
        element(_,_,_),
        licz_el(X),
        E is X + 1,
        retract(licz_el(X)),
        assert(licz_el(E)),
        fail.

liczba_elementoww(W):-
        assert(licz_el(0)),
        not(zlicz_elementyw),!,
        licz_el(W),!,
        retract(licz_el(W)),!.

zlicz_elementyw:-
        mozliwosc(_,_,_,_),
        licz_el(X),
        E is X + 1,
        retract(licz_el(X)),
        assert(licz_el(E)),
        fail.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%     ROZWIAZANIE SUDOKU      %%%

sudoku(L):- nl,nl,nl,
        not(czyszczenie_strzelen), not(czyszczenie),
        write('SUDOKU ZADANE: '),nl,nl,
        wypiszMacierz(L),nl,
        sudoku(L,W), liczba_elementow(N),stan_poczatkowy(M),
        A is N - M, retract(stan_poczatkowy(M)),
        write('Znaleziono elementow: '),write(A),nl,nl,
        write('SUDOKU WYNIKOWE: '),nl,nl,
        wypiszMacierz(W),
        not(czyszczenie),
        not(czyszczenie_strzelen),!.


sudoku(L,W):-
        inicjalizacja(L),!,
        pamiec_stanu_poczatkowego,
        algorytmy,
        strzelenie_liczb,
        rekonstrukcja(W).

pamiec_stanu_poczatkowego:-
        not(stan_poczatkowy(_)),
        liczba_elementow(X),
        assert(stan_poczatkowy(X)).
pamiec_stanu_poczatkowego:-
        stan_poczatkowy(_).

%%% --- DZIAL INICJALIZACJI --- %%%

inicjalizacja(L):-
        not(L = []),
        not(generuj_mozliwosci),!,
        not(generuj_pomoc),!,
        not(wstawiaj_dane(L,1)).

generuj_mozliwosci:-
        cyfra(A),cyfra(B),cyfra(C),
        KW is floor((A-1)/3)*3+ floor((B-1)/3)+1,
        assert(mozliwosc(A,B,KW,C)),
        fail.

generuj_pomoc:-
        cyfra(A),cyfra(B),
        assert(wiersz(A,B)),
        assert(kolumna(A,B)),
        assert(kwadrat(A,B)),
        fail.

wstawiaj_dane([H|T],W):-
        B is W + 1,
        not(wstawiaj_wiersz(H,W,1)),
        wstawiaj_dane(T,B),!.
        

wstawiaj_wiersz([H|T],W,K):-
        H > 0,
        B is K + 1,
        wstawiaj_wartosc(H,W,K),
        wstawiaj_wiersz(T,W,B).


wstawiaj_wiersz([H|T],W,K):-
        H =:= 0,
        B is K + 1,
        wstawiaj_wiersz(T,W,B).


%%% --- DZIAL WSTAWIANIA ELEMENTU --- %%%
%  H - wartosc W - wiersz, K - kolumna  %

wstawiaj_wartosc(H, W, K):-
        not(element(W,K,H)),
        KW is floor((W-1)/3)*3+ floor((K-1)/3)+1,
        assert(element(W,K,H)),!,
        not(usuwaj(H,W,K,KW)).

usuwaj(H,W,K,KW):-
        retract(wiersz(W,H)),
        retract(kolumna(K,H)),
        retract(kwadrat(KW,H)),!,
        usuwaj_mozliwosci(H,W,K).

usuwaj_mozliwosci(_,W,K):-
        mozliwosc(W,K,KW,A),
        retract(mozliwosc(W,K,KW,A)),
        fail.
usuwaj_mozliwosci(X,_,K):-
        mozliwosc(A,K,KW,X),
        retract(mozliwosc(A,K,KW,X)),
        fail.
usuwaj_mozliwosci(X,W,_):-
        mozliwosc(W,A,KW,X),
        retract(mozliwosc(W,A,KW,X)),
        fail.

usuwaj_mozliwosci(X,W,K):-
        KW is floor((W-1)/3)*3+ floor((K-1)/3)+1,!,
        mozliwosc(M,N,KW,X),
        retract(mozliwosc(M,N,KW,X)),
        fail.

usuwaj_mozliwosci(_,_,_).

%%% --- DZIAL WYKONYWANIA ALGORYTMOW --- %%%

algorytmy:-
        not(tylko_jedna_tu),
        not(pionowe_poziome),
        not(jeden_wiersz),
        not(jeden_kolumna),
        not(jeden_kwadrat).

%------------------
pionowe_poziome:-
        mozliwosc(W,K,_,X),
        modyf(W,W1,W2),
        modyf(K,K1,K2),
        (
         (
           (not(wiersz(W1,X));element(W1,K,_)),
           (not(wiersz(W2,X));element(W2,K,_)),
           not(kolumna(K1,X)),
           not(kolumna(K2,X))
         );
         (
           (not(kolumna(K1,X));element(W,K1,_)),
           (not(kolumna(K2,X));element(W,K2,_)),
           not(wiersz(W1,X)),
           not(wiersz(W2,X))
         )
        ),
        wstawiaj_wartosc(X,W,K),!,
        pionowe_poziome.

%------------------
tylko_jedna_tu:-
        mozliwosc(W,K,_,X),
        liczba_mozliwosci(W,K,A),
        A =:= 1,
        wstawiaj_wartosc(X,W,K),
        tylko_jedna_tu.

liczba_mozliwosci(W,K,A):-
        assert(licz_el(0)),
        not(zliczaj_mozliwosci(W,K)),!,
        licz_el(A),!,
        retract(licz_el(A)).

zliczaj_mozliwosci(W,K):-
        mozliwosc(W,K,_,_),
        licz_el(X),
        E is X + 1,
        retract(licz_el(X)),
        assert(licz_el(E)),
        fail.
%------------------     

jeden_wiersz:-
        wiersz(W,X),
        assert(licz_el(0)),
        not(zlicz_mozliwosci(W,_,_,X)),
        licz_el(A),
        retract(licz_el(A)), A =:= 1,
        mozliwosc(W,K,_,X),
        wstawiaj_wartosc(X,W,K),
        fail.

jeden_kolumna:-
        kolumna(K,X),
        assert(licz_el(0)),
        not(zlicz_mozliwosci(_,K,_,X)),
        licz_el(A),
        retract(licz_el(A)), A =:= 1,
        mozliwosc(W,K,_,X),
        wstawiaj_wartosc(X,W,K),
        fail.

jeden_kwadrat:-
        kwadrat(KW,X),
        assert(licz_el(0)),
        not(zlicz_mozliwosci(_,_,KW,X)),
        licz_el(A),
        retract(licz_el(A)),  A =:= 1,
        mozliwosc(W,K,KW,X),
        wstawiaj_wartosc(X,W,K),
        fail.

zlicz_mozliwosci(W,K,KW,X):-
        mozliwosc(W,K,KW,X),
        licz_el(M),
        E is M + 1,
        retract(licz_el(M)),
        assert(licz_el(E)),
        fail.


%%% ---  DZIAL SZCZELANIA LICZBY  --- %%%

strzelenie_liczb:- 
        liczba_elementow(H), H < 81,
        mozliwosc(W,K,_,_),
        zapamietaj_mozliwosc(W,K),
        rekonstrukcja(Q),
        strzelanie_liczb2(W,K,Q),!.

strzelenie_liczb:-
        liczba_elementow(W),W =:= 81,!.

strzelanie_liczb2(W,K,Q):-
        liczba_elementow(H), H =\= 81,
        pamiec_strzelen(W,K,X),
        retract(pamiec_strzelen(W,K,X)),
        not(czyszczenie),
        inicjalizacja(Q),
        wstawiaj_wartosc(X,W,K),
        rekonstrukcja(P),
        not(czyszczenie),
        sudoku(P,_),
        strzelanie_liczb2(W,K,Q),!.

strzelanie_liczb2(_,_,_):-
        liczba_elementow(A), A =:= 81.


zapamietaj_mozliwosc(W,K):-
        mozliwosc(W,K,_,X),not(pamiec_strzelen(W,K,X)),
        assert(pamiec_strzelen(W,K,X)),
        fail.
zapamietaj_mozliwosc(W,K):-
        mozliwosc(W,K,_,_).


%%% ---  REKONSTRUKCJA MACIERZY WYNIKOWEJ  --- %%%

rekonstrukcja(L):-
        wczytaj_dane(L,1),!.

wczytaj_dane([H|T],W):-
        W < 9,
        B is W + 1, B < 10,
        wczytaj_wiersz(H,W,1),
        wczytaj_dane(T,B),!.

wczytaj_dane([H],W):-
        W =:= 9,        
        wczytaj_wiersz(H,W,1).

wczytaj_wiersz([H|T],W,K):-
        K < 9,
        B is K + 1, B < 10,
        czytaj_element(W,K,H),
        wczytaj_wiersz(T,W,B),!.
wczytaj_wiersz([H],W,K):-
        K =:= 9,
        czytaj_element(W,K,H),!.

czytaj_element(W,K,X):-
        element(W,K,X).
czytaj_element(W,K,0):-
        not(element(W,K,_)).
